module HarpiyaExtension
  module ComponentsChecker
    def self.included(base)
      base.extend(ClassMethods)
    end

    module ClassMethods
      def api_available?
        @@api_available ||= engines_classes.include?('Harpiya::Api::Engine')
      end

      def backend_available?
        @@backend_available ||= engines_classes.include?('Harpiya::Backend::Engine')
      end

      def frontend_available?
        @@frontend_available ||= engines_classes.include?('Harpiya::Frontend::Engine')
      end

      def engines_classes
        ::Rails::Engine.subclasses.map(&:instance).map { |e| e.class.to_s }
      end
    end
  end
end